<?php

require_once "extensions/Wikidata/OmegaWiki/WikiDataAPI.php"; // for bootstrapCollection
require_once "extensions/Wikidata/OmegaWiki/Transaction.php";
require __DIR__ . '/includes/WebStart.php';

use MediaWiki\MediaWikiServices;

global $wgUser, $wgRequest;

function getDatasets() {
	$datasets = [];
	$dbr = wfGetDB( DB_REPLICA );
	$result = $dbr->query( "select set_prefix from wikidata_sets" );
	foreach ( $result as $record ) {
		array_push( $datasets, $record->set_prefix );
	}
	return $datasets;
}

function setUser( $userid ) {
	global $wgUser;
	$wgUser->setId( $userid );
	$wgUser->loadFromId();
}

function setDefaultDC( $dc ) {
	global $wgUser, $wdDefaultViewDataSet;

	if ( method_exists( MediaWikiServices::class, 'getUserGroupManager' ) ) {
		// MW 1.35+
		$groups = MediaWikiServices::getInstance()->getUserGroupManager()->getUserGroups( $wgUser );
	} else {
		$groups = $wgUser->getGroups();
	}
	foreach ( $groups as $group ) {
		$wdGroupDefaultView[$group] = $dc;
	}
	$wdDefaultViewDataSet = $dc;
}

function getUserId( $userName ) {
	$dbr = wfGetDB( DB_REPLICA );
	$result = $dbr->query( "select user_id from user where user_name = '$userName'" );
	if ( $row = $result->fetchObject() ) {
		return $row->user_id;
	} else {
		return -1;
	}
}

$userId = getUserId( 'Root' );
if ( $userId == -1 ) {
	echo "root user undefined\n";
	die;
}

setUser( $userId );
$datasets = getDatasets();

$dbr = wfGetDB( DB_REPLICA );
foreach ( $datasets as $dataset ) {
	foreach ( $datasets as $otherdataset ) {
		if ( $dataset != $otherdataset ) {
			echo "mapping between $otherdataset and $dataset\n";
			setDefaultDC( $otherdataset );
			startNewTransaction( $userId, $wgRequest->getIP(), 'Add collection ', $dataset );
			bootstrapCollection( $dataset, '85', 'MAPP' );
		}
	}
}
